// 10mm Pistol. All bullshit by Phanto

datablock AudioProfile(TenmmFire){filename="./10mmFire.wav";description=AudioClosest3d;preload=true;};

datablock ParticleData(TenmmFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.9 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(TenmmFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TenmmFlashParticle";

   uiName = "10mm Flash";
};


AddDamageType("Tenmm",   '<bitmap:add-ons/Weapon_FalloutNV/CI_10mm> %1',    '%2 <bitmap:add-ons/Weapon_FalloutNV/CI_10mm> %1',0.75,1);
datablock ProjectileData(TenmmProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::Tenmm;
   radiusDamageType    = $DamageType::Tenmm;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 14;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 22;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	   = 190;
   verticalImpulse	   = 80;
   explosion           = gunExplosion;
   particleEmitter     = Sil22TrailEmitter;
   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.01;

   hasLight    = false;
   lightRadius = 0.1;
   lightColor  = "0 0 0";
};

//////////
// item //
//////////
datablock ItemData(TenmmItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./10mm.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "10mm Pistol";
	iconName = "./10mm";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.0";

	 // Dynamic properties defined by the scripts
	image = TenmmImage;
	canDrop = true;
	
	//Ammo Guns Parameters
	//maxAmmo = 12;
	//canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TenmmImage)
{

   // Basic Item properties
   shapeFile = "./10mm.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TenmmItem;
   ammo = " ";
   projectile = TenmmProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   
   doColorShift = true;
   colorShiftColor = TenmmItem.colorShiftColor;
	
	stateName[0]                    	= "Activate";
	stateTimeoutValue[0]            	= 0.7;
	stateSequence[0]			= "Use";
	stateTransitionOnTimeout[0]     	= "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    	= "Ready";
	//stateTransitionOnNoAmmo[1]		= "ReloadStart";
	stateTransitionOnTriggerDown[1] 	= "Fire";
	stateAllowImageChange[1]        	= true;
	//stateSequence[1]			= "ready";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.05;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateScript[2]                  	= "onFire";
	stateSequence[2]			= "Fire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]				= TenmmFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= TenmmFire;

	stateName[3] 				= "Smoke";
	stateEmitter[3]				= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.1;
	stateEmitterNode[3]			= "muzzleNode";
	stateTransitionOnTriggerUp[3]     	= "Wait";

	stateName[4]				= "Wait";
	stateTimeoutValue[4]			= 0.03;
	stateTransitionOnTimeout[4]		= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	//stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "ReloadStart";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 0.6;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "ReloadMid";
	stateWaitForTimeout[8]			= true;
	stateSound[8]					= sil22clipout;
	
	stateName[9]				= "ReloadMid";
	stateTimeoutValue[9]			= 0.6;
	stateScript[9]				= "onReloadMid";
	stateTransitionOnTimeout[9]		= "Reloaded";
	stateWaitForTimeout[9]			= true;
	stateSound[9]					= sil22clipin;
	
	stateName[10]				= "Reloaded";
	stateTimeoutValue[10]			= 0.4;
	stateScript[10]				= "onReloaded";
	stateSequence[10]			= "fire";
	stateTransitionOnTimeout[10]		= "Ready";
	stateSound[10]				= Sil22Click;
};

function TenmmImage::onFire(%this,%obj,%slot)
{
	%obj.spawnExplosion(MinorRecoilProjectile,"0.9 0.9 0.9");
	%obj.playThread(2, shiftAway);

	%obj.toolAmmo[%obj.currTool]--;

	%projectile = %this.projectile;
	%spread = 0.0006;

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
}

function TenmmImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, shiftUp);
}

function TenmmImage::onReloadMid(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, shiftRight);
}

function TenmmImage::onReloaded(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.setImageAmmo(%slot,1);
}

function TenmmProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = 15;
   %damage = %directDamage;

   %sobj = %obj.sourceObject; 
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 1.5;
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}