// Silenced .22 Pistol. All bullshit by Phanto

datablock AudioProfile(Sil22Fire2d){filename="./silencedShot2d.wav";description=Audio2d;preload=true;};
datablock AudioProfile(Sil22Fire3d){filename="./silencedShot3d.wav";description=AudioClosest3d;preload=true;};
datablock AudioProfile(Sil22Click){filename="./Sil22Click.wav";description=AudioClosest3d;preload=true;};
datablock AudioProfile(Sil22Clipin){filename="./clipin.wav";description=AudioClosest3d;preload=true;};
datablock AudioProfile(Sil22Clipout){filename="./clipout.wav";description=AudioClosest3d;preload=true;};

datablock ParticleData(Sil22FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.9 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Sil22FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Sil22FlashParticle";

   uiName = "Sil22 Flash";
};

datablock ParticleData(Sil22TrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 120;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 0 1";
	colors[1]	= "1 1 0.4 1";
	colors[2]	= "1 1 1 1";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(Sil22TrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = Sil22TrailParticle;

   useEmitterColors = true;
};

AddDamageType("Sil22",   '<bitmap:add-ons/Weapon_FalloutNV/CI_Sil22> %1',    '%2 <bitmap:add-ons/Weapon_FalloutNV/CI_Sil22> %1',0.75,1);
datablock ProjectileData(Sil22Projectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::Sil22;
   radiusDamageType    = $DamageType::Sil22;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 14;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 22;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	   = 190;
   verticalImpulse	   = 80;
   explosion           = gunExplosion;
   particleEmitter     = Sil22TrailEmitter;
   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.01;

   hasLight    = false;
   lightRadius = 0.0;
   lightColor  = "0 0 0";
};

//////////
// item //
//////////
datablock ItemData(Sil22Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ruger.dts";
	//shapeFile = "./rounrudger.dts"; - This was the old model. The barrel is a cylinder. If you like it more, use it.
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Silenced .22 Pistol";
	iconName = "./sil22";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.0";

	 // Dynamic properties defined by the scripts
	image = Sil22Image;
	canDrop = true;
	
	//Ammo Guns Parameters
	//maxAmmo = 16;
	//canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Sil22Image)
{

   // Basic Item properties
   shapeFile = "./ruger.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Sil22Item;
   ammo = " ";
   projectile = Sil22Projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
	
	stateName[0]                    	= "Activate";
	stateTimeoutValue[0]            	= 0.7;
	stateSequence[0]			= "Use";
	stateTransitionOnTimeout[0]     	= "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    	= "Ready";
	//stateTransitionOnNoAmmo[1]		= "ReloadStart";
	stateTransitionOnTriggerDown[1] 	= "Fire";
	stateAllowImageChange[1]        	= true;
	//stateSequence[1]			= "ready";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.05;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateScript[2]                  	= "onFire";
	stateSequence[2]			= "Fire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]				= Sil22FlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= Sil22Fire3d;

	stateName[3] 				= "Smoke";
	stateEmitter[3]				= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.1;
	stateEmitterNode[3]			= "muzzleNode";
	stateTransitionOnTriggerUp[3]     	= "Wait";

	stateName[4]				= "Wait";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	//stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "ReloadStart";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 0.6;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "ReloadMid";
	stateWaitForTimeout[8]			= true;
	stateSound[8]					= sil22clipout;
	
	stateName[9]				= "ReloadMid";
	stateTimeoutValue[9]			= 0.6;
	stateScript[9]				= "onReloadMid";
	stateTransitionOnTimeout[9]		= "Reloaded";
	stateWaitForTimeout[9]			= true;
	stateSound[9]					= sil22clipin;
	
	stateName[10]				= "Reloaded";
	stateTimeoutValue[10]			= 0.4;
	stateScript[10]				= "onReloaded";
	stateSequence[10]			= "fire";
	stateTransitionOnTimeout[10]		= "Ready";
	stateSound[10]				= Sil22Click;
};

function Sil22Image::onFire(%this,%obj,%slot)
{
	if(isObject(%obj.client))
	{
		%obj.client.play2d(Sil22Fire2d);
	}
	%obj.spawnExplosion(MinorRecoilProjectile,"0.5 0.5 0.5");
	%obj.playThread(2, shiftAway);

	%obj.toolAmmo[%obj.currTool]--;

	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%spread = 0.001;
	}
	else
	{
		%spread = 0.0001;
	}

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
}

function Sil22Image::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, shiftUp);
}

function Sil22Image::onReloadMid(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, shiftRight);
}

function Sil22Image::onReloaded(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.setImageAmmo(%slot,1);
}

function Sil22Projectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = 10;
   %damage = %directDamage;

   %sobj = %obj.sourceObject; 
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 1.5;
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}